%global branch 23.08
%global version 23.08.28
%global llvm_major 18
%global llvm_version 18.1.8
%global rust_version 1.81.0

# Check for updates with:
#  flatpak remote-info --arch=aarch64 flathub org.freedesktop.Platform//23.08
#  flatpak remote-info --arch=aarch64 flathub org.freedesktop.Sdk//23.08
#  flatpak remote-info --arch=aarch64 flathub org.freedesktop.Sdk.Extension.llvm18//23.08
#  flatpak remote-info --arch=aarch64 flathub org.freedesktop.Sdk.Extension.rust-stable//23.08

%ifarch aarch64
%global platform_commit 4f604d9612f156f224c1fa8a5f1380fa9b78ef95b34392f20edb1b1f63d52996
%global sdk_commit 202229c2e5fdbe4eb79f7aea4a81908cbe3104d474f8b9b9ea0716c94d7c3f38
%global llvm_commit 72da52d1f552e891f087005dd79ef864811a5a06df566d6cd0e59947abf01651
%global rust_commit ab0633847188bbd94c500c7240194ea22c47cde1f5e1b88d7833eb463e8e8936
%endif

# Check for updates with:
#  flatpak remote-info --arch=x86_64 flathub org.freedesktop.Platform//23.08
#  flatpak remote-info --arch=x86_64 flathub org.freedesktop.Sdk//23.08
#  flatpak remote-info --arch=x86_64 flathub org.freedesktop.Sdk.Extension.llvm18//23.08
#  flatpak remote-info --arch=x86_64 flathub org.freedesktop.Sdk.Extension.rust-stable//23.08

%ifarch x86_64
%global platform_commit 507806048b865751a58580843c9dd77983fea138f268f1fb442474c9d4c46051
%global sdk_commit a69bbaaeda32f0970cdb92a199d148416e87416f48f4484b0db07df27f074db3
%global llvm_commit 5311e43c5398b2ce50a935c761693faf80d0079afb2232b9fbc00a1138215a38
%global rust_commit 81caf9b122cf28c012ba390c40c68b5f89568951aab748383f92c86000e5d2a4
%endif

Name:           fdo-sdk-%{branch}-flatpak
Summary:        Flatpak Freedesktop SDK
Version:        %{version}
Release:        1
License:        MIT AND Apache-2.0 WITH LLVM-exception
URL:            https://freedesktop-sdk.gitlab.io/

BuildRequires:  flatpak

BuildArch:      aarch64 x86_64 %{ix86}

%description
%{summary}.

%package -n fdo-runtime-%{branch}-flatpak
Summary:        Flatpak Freedesktop Runtime

%description -n fdo-runtime-%{branch}-flatpak
%{summary}.

%package -n fdo-sdk-extension-llvm%{llvm_major}-%{branch}-flatpak
Version:        %{llvm_version}
Summary:        Flatpak Freedesktop SDK llvm%{llvm_major} extension

%description -n fdo-sdk-extension-llvm%{llvm_major}-%{branch}-flatpak
%{summary}.

%package -n fdo-sdk-extension-rust-stable-%{branch}-flatpak
Version:        %{rust_version}
Summary:        Flatpak Freedesktop SDK rust-stable extension

%description -n fdo-sdk-extension-rust-stable-%{branch}-flatpak
%{summary}.

%prep
flatpak remote-add --user flathub https://dl.flathub.org/repo/flathub.flatpakrepo
flatpak remote-modify --user --collection-id=org.flathub.Stable flathub

%build
flatpak install --assumeyes --no-deps --no-related --user flathub org.freedesktop.Platform//%{branch}
flatpak update --assumeyes --no-deps --no-related --user --commit=%{platform_commit} org.freedesktop.Platform//%{branch}
flatpak install --assumeyes --no-deps --no-related --user flathub org.freedesktop.Sdk//%{branch}
flatpak update --assumeyes --no-deps --no-related --user --commit=%{sdk_commit} org.freedesktop.Sdk//%{branch}
flatpak install --assumeyes --no-deps --no-related --user flathub org.freedesktop.Sdk.Extension.llvm%{llvm_major}//%{branch}
flatpak update --assumeyes --no-deps --no-related --user --commit=%{llvm_commit} org.freedesktop.Sdk.Extension.llvm%{llvm_major}//%{branch}
flatpak install --assumeyes --no-deps --no-related --user flathub org.freedesktop.Sdk.Extension.rust-stable//%{branch}
flatpak update --assumeyes --no-deps --no-related --user --commit=%{rust_commit} org.freedesktop.Sdk.Extension.rust-stable//%{branch}

%install
mkdir -p %{buildroot}%{_datadir}/flatpak-sideload/{fdo-sdk,fdo-runtime,fdo-sdk-extension-llvm%{llvm_major},fdo-sdk-extension-rust-stable}-%{branch}
flatpak create-usb --user %{buildroot}%{_datadir}/flatpak-sideload/fdo-sdk-%{branch} org.freedesktop.Sdk//%{branch}
flatpak create-usb --user %{buildroot}%{_datadir}/flatpak-sideload/fdo-runtime-%{branch} org.freedesktop.Platform//%{branch}
flatpak create-usb --user %{buildroot}%{_datadir}/flatpak-sideload/fdo-sdk-extension-llvm%{llvm_major}-%{branch} org.freedesktop.Sdk.Extension.llvm%{llvm_major}//%{branch}
flatpak create-usb --user %{buildroot}%{_datadir}/flatpak-sideload/fdo-sdk-extension-rust-stable-%{branch} org.freedesktop.Sdk.Extension.rust-stable//%{branch}

%files
%{_datadir}/flatpak-sideload/fdo-sdk-%branch

%files -n fdo-runtime-%{branch}-flatpak
%{_datadir}/flatpak-sideload/fdo-runtime-%branch

%files -n fdo-sdk-extension-llvm%{llvm_major}-%{branch}-flatpak
%{_datadir}/flatpak-sideload/fdo-sdk-extension-llvm%{llvm_major}-%branch

%files -n fdo-sdk-extension-rust-stable-%{branch}-flatpak
%{_datadir}/flatpak-sideload/fdo-sdk-extension-rust-stable-%branch

%changelog
* Fri Feb 28 2025 Janne Grunau <janne-fdr@jannau.net> - 23.08.28-1
- Update to fdo-sdk 23.08.28

* Fri Dec 06 2024 Asahi Lina <lina@asahilina.net> - 23.08.25-1
- Add rust-stable extension
- Bump to fdo-sdk 23.08.25

* Mon Jul 15 2024 Hector Martin <marcan@fedoraproject.org> - 23.08.20-1
- Initial release
